Subject: Re: [PATCH bpf-next V1 3/6] bpf: add BPF-helper for reading MTU from net_device via ifindex

From: Jesper Dangaard Brouer <[email-masked]>
Date: Wed, 7 Oct 2020 09:53:48 +0200

On Tue, 6 Oct 2020 18:24:28 -0700
Maciej Żenczykowski <[email-masked]> wrote:

> On Tue, Oct 6, 2020 at 6:19 PM Jakub Kicinski <[email-masked]> wrote:
> >
> > On Tue, 6 Oct 2020 18:33:02 +0200 Jesper Dangaard Brouer wrote:  
> > > > +static const struct bpf_func_proto bpf_xdp_mtu_lookup_proto = {
> > > > +   .func           = bpf_xdp_mtu_lookup,
> > > > +   .gpl_only       = true,
> > > > +   .ret_type       = RET_INTEGER,
> > > > +   .arg1_type      = ARG_PTR_TO_CTX,
> > > > +   .arg2_type      = ARG_ANYTHING,
> > > > +   .arg3_type      = ARG_ANYTHING,
> > > > +};
> > > > +
> > > > +  
> >
> > FWIW
> >
> > CHECK: Please don't use multiple blank lines
> > #112: FILE: net/core/filter.c:5566:  
> 
> FYI: It would be nice to have a similar function to return a device's
> L2 header size (ie. 14 for ethernet) and/or hwtype.
> 
> Also, should this be restricted to gpl only?

That is mostly because I copy-pasted it from the fib lookup helper,
which with good reason is GPL.  I would prefer it to be GPL, but given
how simple it is I shouldn't.  Maybe I could argue that my new mtu_check
could be GPL as it does more work.

> [I'm not actually sure, I'm actually fed up with non-gpl code atm, and
> wouldn't be against all bpf code needing to be gpl'ed...]

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer